const {prompt} = require('inquirer');
const {writeFile} = require('fs');
const {error} = require('./logger');
const utils = require('./utils');
const listTable = utils.listTable;
let tplList = utils.tplList;
/**
 * getQuestion: 获取命令行输入属性
 * @return {array} 属性列表
 */
const getQuestion = () => {
  return [
    {
      type: 'input',
      name: 'templateName',
      message: '输入要删除的模板名称:'
    }
  ]
};
/**
 * delTemplate: 删除模板，重写template.json文件
 * @param  {string} templateName  要删除的模板名
 */
const delTemplate = (templateName) => {
  if (tplList[templateName]) {
    delete tplList[templateName];
    writeFile(`${__dirname}/../templates.json`, JSON.stringify(tplList), 'utf-8', (err) => {
      if (err) {
        error(err);
      }
      listTable(tplList, '模板删除成功！')
    })
  } else {
    error('模板不存在!');
    listTable(tplList);
    process.exit();
  }
}
/**
 * delCli 删除命令处理
 * @param  {string} args 删除命令所带参数值
 */
const delCli = (args) => {
  if ((Object.keys(tplList)).length == 0) {
    error('模板列表为空，无需删除');
    process.exit();
  }
  if (args) {
    delTemplate(args);
  } else {
    const question = getQuestion();
    prompt(question).then(({templateName}) => {
      delTemplate(templateName);
    })
  }
}
module.exports = delCli;
