'use strict'

const Table = require('cli-table');
const tplList = require(`${__dirname}/../templates`);
const {info, error, success} = require('./logger');

const table = new Table({
  head: [
    'Template Name', 'Repositorie Owner', 'Repositorie', 'Branch'
  ],
  style: {
    head: ['green']
  }
})

const listTable = (tplList, lyric) => {
  const list = Object.keys(tplList);
  if (list.length) {
    list.forEach((key) => {
      table.push([key, tplList[key]['repositorieOwnerName'], tplList[key]['repositorie'], tplList[key]['branch']
      ])
      if (table.length === list.length) {
        info(table.toString())
        if (lyric) {
          success(lyric);
        }
        process.exit()
      }
    })
  } else {
    info(table.toString())
    if (lyric) {
      success(lyric)
    }
    process.exit()
  }
}

exports.tplList = tplList;
exports.listTable = listTable;
